#include <unistd.h>
#include <sys/wait.h>

#include <vector>
#include "morfofun.hh"

template<class T>
const T& Struktit<T>::find(const string& word) const
{
    std::vector<unsigned> choices;
    
    for(unsigned a=0; a<struktit.size(); ++a)
        if(Match(word, struktit[a].mask))
            choices.push_back(a);
    
    for(unsigned a=0; a<choices.size(); ++a)
    {
        if(a+1 < choices.size())
        {
            fflush(stdout);
            fflush(stderr);
            
            int pid = fork();
            if(pid != 0)
            {
                wait(NULL);
                continue;
            }
        }
        const unsigned choice = choices[a];
        fprintf(stderr, "[%sdebug]: '%s' match %u/%u: '%s'\n",
            type,
            word.c_str(),
            a+1, choices.size(),
            struktit[choice].mask.c_str());
        return struktit[choice];
    }

    fprintf(stderr, "Onko '%s' varmasti %s?\n", word.c_str(), type);
    return struktit[0]; /* Means "fail" */
}
