#include "morfofun.hh"
#include "nominimorfo.hh"

using std::sprintf;

namespace
{
    class NomiStruct
    {
    public:
        string mask;
        
        string nom[2], gen[2], akk[2], ess[2], par[2], tra[2],
               ine[2], ela[2], ill[2],
               ade[2], abl[2], all[2], abe[2],
               kom[2], ins[2], person;
        string mul; // -sti
        string kompa[2], super[2];

        void set(const string& hdr, const vector<string>& tab)
        {
            if(!tab.size())return;
            if(hdr=="Mul") { mul = tab[0]; return; }
            if(hdr=="Person") { person = tab[0]; return; }
    #include "nomihash.inc"
        }

        void clear()
        {
            mask.erase();
            for(unsigned a=0; a<2; ++a)
                nom[a].erase(), gen[a].erase(), akk[a].erase(),
                ess[a].erase(), par[a].erase(), tra[a].erase(),
                ine[a].erase(), ela[a].erase(), ill[a].erase(),
                ade[a].erase(), abl[a].erase(), all[a].erase(),
                kom[a].erase(), ins[a].erase(), abe[a].erase(),
                kompa[a].erase(), super[a].erase();
            mul.erase();
        }
        
        const string Replace(const string& word, const string& pat) const
        {
            return ::Replace(word, mask, pat);
        }
    };

    class PersStruct
    {
    public:
        string mask; // unused
        void clear() { } // unused
        
        string nom[12], gen[6], akk[6], ess[6], par[6], tra[6],
               ine[6], ela[6], ill[6], ade[6], abl[6], all[6],
               abe[6], kom[6], ins[6], kompa[6], super[6];

        void set(const string& hdr, const vector<string>& tab)
        {
            if(!tab.size())return;
            if(hdr=="Nom") { for(unsigned a=0; a<tab.size(); ++a)if(a<12)nom[a]=tab[a]; return; }
            if(hdr=="Gen") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)gen[a]=tab[a]; return; }
            if(hdr=="Akk") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)akk[a]=tab[a]; return; }
            if(hdr=="Ess") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ess[a]=tab[a]; return; }
            if(hdr=="Par") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)par[a]=tab[a]; return; }
            if(hdr=="Tra") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)tra[a]=tab[a]; return; }
            if(hdr=="Ine") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ine[a]=tab[a]; return; }
            if(hdr=="Ela") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ela[a]=tab[a]; return; }
            if(hdr=="Ill") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ill[a]=tab[a]; return; }
            if(hdr=="Ade") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ade[a]=tab[a]; return; }
            if(hdr=="Abl") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)abl[a]=tab[a]; return; }
            if(hdr=="All") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)all[a]=tab[a]; return; }
            if(hdr=="Abe") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)abe[a]=tab[a]; return; }
            if(hdr=="Kom") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)kom[a]=tab[a]; return; }
            if(hdr=="Ins") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ins[a]=tab[a]; return; }
            if(hdr=="Kompa") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)kompa[a]=tab[a]; return; }
            if(hdr=="Super") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)super[a]=tab[a]; return; }
        }
        const string Replace(const string& word, const string& pat) const
        {
            unsigned a=0, b=word.size();
            bool yla = true;
            while(a < pat.size() && b > 0 && pat[a]=='-')--b, ++a;
            string s = word.substr(0, b);
            for(; b > 0; --b)if(word[b]=='a'||word[b]=='A'
                              ||word[b]=='o'||word[b]=='O'
                              ||word[b]=='u'||word[b]=='U'){yla=false;break;}
            for(; a < pat.size(); ++a)
                s += (pat[a]=='a' && yla) ? '' : pat[a];
            return s;
        }
    };

    Struktit<NomiStruct> NomiStruktit("nomiruumiit.txt",   "nomini");
    Struktit<NomiStruct> InfiStruktit("infiniruumiit.txt", "infinitiivi");
    Struktit<PersStruct> PersStruktit("persoonat.txt",     "persoona");

    const string Omistusliite(const NomiStruct& btr,const string& base,
                              const string& word, sijamuoto sija,
                              bool monikko, persoona pers)
    {
        if(pers < YKS1 || pers > MON3)return word;    
        const PersStruct& str = PersStruktit.find(word);
        
        if(sija == NOMINATIIVI)
        {
            if(monikko)
                return str.Replace(word, str.nom[6 + pers]);
            return str.Replace(btr.Replace(base, btr.person), str.nom[0 + pers]);
        }
        if(sija == GENETIIVI)return str.Replace(word, str.gen[pers]);
        if(sija == AKKUSATIIVI)return str.Replace(word, str.akk[pers]);
        if(sija == ESSIIVI)return str.Replace(word, str.ess[pers]);
        if(sija == PARTITIIVI)return str.Replace(word, str.par[pers]);
        if(sija == TRANSLATIIVI)return str.Replace(word, str.tra[pers]);
        if(sija == INESSIIVI)return str.Replace(word, str.ine[pers]);
        if(sija == ELATIIVI)return str.Replace(word, str.ela[pers]);
        if(sija == ILLATIIVI)return str.Replace(word, str.ill[pers]);
        if(sija == ADESSIIVI)return str.Replace(word, str.ade[pers]);
        if(sija == ABLATIIVI)return str.Replace(word, str.abl[pers]);
        if(sija == ALLATIIVI)return str.Replace(word, str.all[pers]);
        if(sija == ABESSIIVI)return str.Replace(word, str.abe[pers]);
        if(sija == KOMITATIIVI)return str.Replace(word, str.kom[pers]);
        if(sija == INSTRUKTIIVI)return str.Replace(word, str.ins[pers]);
        //if(sija == KOMPARATIIVI)return str.Replace(word, str.kompa[pers]);
        //if(sija == SUPERLATIIVI)return str.Replace(word, str.super[pers]);
        if(sija == MULTIPLIKATIIVI)
        {
            if(pers != PASSIIVI)
                fprintf(stderr, "%s: Multiplikatiiviin ei voi liitt persoonaptett.\n", base.c_str());
            return word;
        }

        char Buf[128];
        sprintf(Buf, "?pers:sija=%u,word=", sija);
        return Buf + word;
    }
    
    const string Taivuta(const string& word, sijamuoto sija,
                         bool monikko, persoona pers,
                         const NomiStruct& str)
    {
        if(sija == INSTRUKTIIVI && pers != PASSIIVI)
        {
            fprintf(stderr, "%s: Instruktiivi ei esiinny yhdess omistusliitteen kanssa. Otetaan moinen siis pois.\n", word.c_str());
            pers = PASSIIVI;
        }
        
        string taivutettu = word;
        
        switch(sija)
        {
            case NOMINATIIVI: taivutettu = str.Replace(word, str.nom[monikko?1:0]); break;
            case GENETIIVI: taivutettu = str.Replace(word, str.gen[monikko?1:0]); break;
            case AKKUSATIIVI: taivutettu = str.Replace(word, str.akk[monikko?1:0]); break;
            case ESSIIVI: taivutettu = str.Replace(word, str.ess[monikko?1:0]); break;
            case PARTITIIVI: taivutettu = str.Replace(word, str.par[monikko?1:0]); break;
            case TRANSLATIIVI: taivutettu = str.Replace(word, str.tra[monikko?1:0]); break;
            case INESSIIVI: taivutettu = str.Replace(word, str.ine[monikko?1:0]); break;
            case ELATIIVI: taivutettu = str.Replace(word, str.ela[monikko?1:0]); break;
            case ILLATIIVI: taivutettu = str.Replace(word, str.ill[monikko?1:0]); break;
            case ADESSIIVI: taivutettu = str.Replace(word, str.ade[monikko?1:0]); break;
            case ABLATIIVI: taivutettu = str.Replace(word, str.abl[monikko?1:0]); break;
            case ALLATIIVI: taivutettu = str.Replace(word, str.all[monikko?1:0]); break;
            case ABESSIIVI: taivutettu = str.Replace(word, str.abe[monikko?1:0]); break;
            case KOMITATIIVI: taivutettu = str.Replace(word, str.kom[monikko?1:0]); break;
            case INSTRUKTIIVI: taivutettu = str.Replace(word, str.ins[monikko?1:0]); break;
            //case KOMPARATIIVI: taivutettu = str.Replace(word, str.kompa[monikko?1:0]); break;
            //case SUPERLATIIVI: taivutettu = str.Replace(word, str.super[monikko?1:0]); break;
            case MULTIPLIKATIIVI: taivutettu = str.Replace(word, str.mul); break;
            default:
            {
                char Buf[128];
                sprintf(Buf, "?nom:sija=%u,word=\n", sija);
                return Buf + word;
            }
        }
        return Omistusliite(str, word, taivutettu, sija, monikko, pers);
    }
}

void InfiniMuotoTarkistus(unsigned infinum, const string& word,
                          sijamuoto& sija,
                          bool& monikko,
                          persoona& pers)
{
    if(infinum==1 && (monikko || (sija!=NOMINATIIVI && sija!=TRANSLATIIVI)))
    {
        sija = NOMINATIIVI;
        monikko = false;
        fprintf(stderr, "%s: I infinitiivist on vain yksikn nominatiivi ja yksikn translatiivi. Kytmme siis nominatiivia.\n", word.c_str());
    }
    else if(infinum==2 && (sija!=INESSIIVI && sija!=INSTRUKTIIVI))
    {
        sija = INESSIIVI;
        fprintf(stderr, "%s: II infinitiivist on vain yksikn inessiivi ja yksikn instruktiivi. Kytmme siis inessiivi.\n", word.c_str());
    }
/*
    else if(infinum==3 && (pers==PASSIIVI) && (monikko || sija!=INSTRUKTIIVI))
    {
        sija = INSTRUKTIIVI; monikko = false;
        fprintf(stderr, "%s: III infinitiivist ei ole passiivissa kuin yksikn instruktiivi. Kytmme siis instruktiivia.\n", word.c_str());
    }
    - no onpa - "symtt ei el" on ok
*/
    else if(infinum==5 && (monikko || sija!=ADESSIIVI))
    {
        sija = ADESSIIVI;
        monikko = false;
        fprintf(stderr, "%s: V infinitiivist on vain yksikn adessiivi. Kytmme siis sit.\n", word.c_str());
    }
    if(infinum==1 && sija==NOMINATIIVI && pers != PASSIIVI)
    {
        pers = PASSIIVI;
        fprintf(stderr, "%s: I infinitiivin nominatiivilla ei ole omistusliitteellist versiota. Otetaan moinen siis pois.\n", word.c_str());
    }

/*
    if(sija==TRANSLATIIVI && pers == PASSIIVI)
    {
        pers = YKS1;
        fprintf(stderr, "%s: Infinitiivien translatiivilla ei ole omistusliitteetnt versiota. Kytmme siis yksikn ensimmist persoonaa.\n", word.c_str());
    }
    - no onpa - "tuli karhun symksi" on ok
*/

    if(infinum==5 && pers == PASSIIVI)
    {
        pers = YKS1;
        fprintf(stderr, "%s: V infinitiivill ei ole omistusliitteettmi sijoja. Kytmme siis yksikn ensimmist persoonaa.\n", word.c_str());
    }
}

const string NominiTaivutus(const string& word, sijamuoto sija, bool monikko, persoona pers)
{
    return Taivuta(word, sija, monikko, pers, NomiStruktit.find(word));
}

const string InfiniTaivutus(const string& word, sijamuoto sija, bool monikko, persoona pers)
{
    return Taivuta(word, sija, monikko, pers, InfiStruktit.find(word));
}
